diff --git a/drivers/net/nfp/flower/nfp_flower.h b/drivers/net/nfp/flower/nfp_flower.h
index 0b4e38cedd..b7ea830209 100644
--- a/drivers/net/nfp/flower/nfp_flower.h
+++ b/drivers/net/nfp/flower/nfp_flower.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_FLOWER_H_
-#define _NFP_FLOWER_H_
+#ifndef __NFP_FLOWER_H__
+#define __NFP_FLOWER_H__
 
 #include "../nfp_common.h"
 
@@ -118,4 +118,4 @@ int nfp_flower_pf_stop(struct rte_eth_dev *dev);
 uint32_t nfp_flower_pkt_add_metadata(struct nfp_app_fw_flower *app_fw_flower,
 		struct rte_mbuf *mbuf, uint32_t port_id);
 
-#endif /* _NFP_FLOWER_H_ */
+#endif /* __NFP_FLOWER_H__ */
diff --git a/drivers/net/nfp/flower/nfp_flower_cmsg.h b/drivers/net/nfp/flower/nfp_flower_cmsg.h
index cb019171b6..c2938fb6f6 100644
--- a/drivers/net/nfp/flower/nfp_flower_cmsg.h
+++ b/drivers/net/nfp/flower/nfp_flower_cmsg.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_CMSG_H_
-#define _NFP_CMSG_H_
+#ifndef __NFP_CMSG_H__
+#define __NFP_CMSG_H__
 
 #include "../nfp_flow.h"
 #include "nfp_flower.h"
@@ -989,4 +989,4 @@ int nfp_flower_cmsg_qos_delete(struct nfp_app_fw_flower *app_fw_flower,
 int nfp_flower_cmsg_qos_stats(struct nfp_app_fw_flower *app_fw_flower,
 		struct nfp_cfg_head *head);
 
-#endif /* _NFP_CMSG_H_ */
+#endif /* __NFP_CMSG_H__ */
diff --git a/drivers/net/nfp/flower/nfp_flower_ctrl.h b/drivers/net/nfp/flower/nfp_flower_ctrl.h
index f73a024266..4c94d36847 100644
--- a/drivers/net/nfp/flower/nfp_flower_ctrl.h
+++ b/drivers/net/nfp/flower/nfp_flower_ctrl.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_FLOWER_CTRL_H_
-#define _NFP_FLOWER_CTRL_H_
+#ifndef __NFP_FLOWER_CTRL_H__
+#define __NFP_FLOWER_CTRL_H__
 
 #include "nfp_flower.h"
 
@@ -13,4 +13,4 @@ uint16_t nfp_flower_ctrl_vnic_xmit(struct nfp_app_fw_flower *app_fw_flower,
 		struct rte_mbuf *mbuf);
 void nfp_flower_ctrl_vnic_xmit_register(struct nfp_app_fw_flower *app_fw_flower);
 
-#endif /* _NFP_FLOWER_CTRL_H_ */
+#endif /* __NFP_FLOWER_CTRL_H__ */
diff --git a/drivers/net/nfp/flower/nfp_flower_representor.h b/drivers/net/nfp/flower/nfp_flower_representor.h
index eda19cbb16..bcb4c3cdb5 100644
--- a/drivers/net/nfp/flower/nfp_flower_representor.h
+++ b/drivers/net/nfp/flower/nfp_flower_representor.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_FLOWER_REPRESENTOR_H_
-#define _NFP_FLOWER_REPRESENTOR_H_
+#ifndef __NFP_FLOWER_REPRESENTOR_H__
+#define __NFP_FLOWER_REPRESENTOR_H__
 
 #include "nfp_flower.h"
 
@@ -24,4 +24,4 @@ struct nfp_flower_representor {
 
 int nfp_flower_repr_create(struct nfp_app_fw_flower *app_fw_flower);
 
-#endif /* _NFP_FLOWER_REPRESENTOR_H_ */
+#endif /* __NFP_FLOWER_REPRESENTOR_H__ */
diff --git a/drivers/net/nfp/nfd3/nfp_nfd3.h b/drivers/net/nfp/nfd3/nfp_nfd3.h
index 0b0ca361f4..3ba562cc3f 100644
--- a/drivers/net/nfp/nfd3/nfp_nfd3.h
+++ b/drivers/net/nfp/nfd3/nfp_nfd3.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_NFD3_H_
-#define _NFP_NFD3_H_
+#ifndef __NFP_NFD3_H__
+#define __NFP_NFD3_H__
 
 #include "../nfp_rxtx.h"
 
@@ -84,4 +84,4 @@ int nfp_net_nfd3_tx_queue_setup(struct rte_eth_dev *dev,
 		unsigned int socket_id,
 		const struct rte_eth_txconf *tx_conf);
 
-#endif /* _NFP_NFD3_H_ */
+#endif /* __NFP_NFD3_H__ */
diff --git a/drivers/net/nfp/nfp_common.h b/drivers/net/nfp/nfp_common.h
index 27dc2175e3..11eda70f1a 100644
--- a/drivers/net/nfp/nfp_common.h
+++ b/drivers/net/nfp/nfp_common.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_COMMON_H_
-#define _NFP_COMMON_H_
+#ifndef __NFP_COMMON_H__
+#define __NFP_COMMON_H__
 
 #include <bus_pci_driver.h>
 #include <ethdev_driver.h>
@@ -450,4 +450,4 @@ bool nfp_net_is_valid_nfd_version(struct nfp_net_fw_ver version);
 #define NFP_PRIV_TO_APP_FW_FLOWER(app_fw_priv)\
 	((struct nfp_app_fw_flower *)app_fw_priv)
 
-#endif /* _NFP_COMMON_H_ */
+#endif /* __NFP_COMMON_H__ */
diff --git a/drivers/net/nfp/nfp_cpp_bridge.h b/drivers/net/nfp/nfp_cpp_bridge.h
index e6a957a090..a1103e85e4 100644
--- a/drivers/net/nfp/nfp_cpp_bridge.h
+++ b/drivers/net/nfp/nfp_cpp_bridge.h
@@ -1,16 +1,14 @@
 /* SPDX-License-Identifier: BSD-3-Clause
  * Copyright (c) 2014-2021 Netronome Systems, Inc.
  * All rights reserved.
- *
- * Small portions derived from code Copyright(c) 2010-2015 Intel Corporation.
  */
 
-#ifndef _NFP_CPP_BRIDGE_H_
-#define _NFP_CPP_BRIDGE_H_
+#ifndef __NFP_CPP_BRIDGE_H__
+#define __NFP_CPP_BRIDGE_H__
 
 #include "nfp_common.h"
 
 int nfp_enable_cpp_service(struct nfp_pf_dev *pf_dev);
 int nfp_map_service(uint32_t service_id);
 
-#endif /* _NFP_CPP_BRIDGE_H_ */
+#endif /* __NFP_CPP_BRIDGE_H__ */
diff --git a/drivers/net/nfp/nfp_ctrl.h b/drivers/net/nfp/nfp_ctrl.h
index ef8bf486cb..71fe125420 100644
--- a/drivers/net/nfp/nfp_ctrl.h
+++ b/drivers/net/nfp/nfp_ctrl.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_CTRL_H_
-#define _NFP_CTRL_H_
+#ifndef __NFP_CTRL_H__
+#define __NFP_CTRL_H__
 
 #include <stdint.h>
 
@@ -573,4 +573,4 @@ nfp_net_cfg_ctrl_rss(uint32_t hw_cap)
 	return NFP_NET_CFG_CTRL_RSS;
 }
 
-#endif /* _NFP_CTRL_H_ */
+#endif /* __NFP_CTRL_H__ */
diff --git a/drivers/net/nfp/nfp_flow.h b/drivers/net/nfp/nfp_flow.h
index 5a5b6a7d19..d4bde0a294 100644
--- a/drivers/net/nfp/nfp_flow.h
+++ b/drivers/net/nfp/nfp_flow.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_FLOW_H_
-#define _NFP_FLOW_H_
+#ifndef __NFP_FLOW_H__
+#define __NFP_FLOW_H__
 
 #include "nfp_common.h"
 
@@ -164,4 +164,4 @@ int nfp_flow_priv_init(struct nfp_pf_dev *pf_dev);
 void nfp_flow_priv_uninit(struct nfp_pf_dev *pf_dev);
 int nfp_net_flow_ops_get(struct rte_eth_dev *dev, const struct rte_flow_ops **ops);
 
-#endif /* _NFP_FLOW_H_ */
+#endif /* __NFP_FLOW_H__ */
diff --git a/drivers/net/nfp/nfp_logs.h b/drivers/net/nfp/nfp_logs.h
index 16ff61700b..690adabffd 100644
--- a/drivers/net/nfp/nfp_logs.h
+++ b/drivers/net/nfp/nfp_logs.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_LOGS_H_
-#define _NFP_LOGS_H_
+#ifndef __NFP_LOGS_H__
+#define __NFP_LOGS_H__
 
 #include <rte_log.h>
 
@@ -41,4 +41,4 @@ extern int nfp_logtype_driver;
 	rte_log(RTE_LOG_ ## level, nfp_logtype_driver, \
 		"%s(): " fmt "\n", __func__, ## args)
 
-#endif /* _NFP_LOGS_H_ */
+#endif /* __NFP_LOGS_H__ */
diff --git a/drivers/net/nfp/nfp_rxtx.h b/drivers/net/nfp/nfp_rxtx.h
index 899cc42c97..956cc7a0d2 100644
--- a/drivers/net/nfp/nfp_rxtx.h
+++ b/drivers/net/nfp/nfp_rxtx.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_RXTX_H_
-#define _NFP_RXTX_H_
+#ifndef __NFP_RXTX_H__
+#define __NFP_RXTX_H__
 
 #include <ethdev_driver.h>
 
@@ -253,4 +253,4 @@ void nfp_net_set_meta_ipsec(struct nfp_net_meta_raw *meta_data,
 		uint8_t layer,
 		uint8_t ipsec_layer);
 
-#endif /* _NFP_RXTX_H_ */
+#endif /* __NFP_RXTX_H__ */