diff --git a/drivers/net/nfp/flower/nfp_flower.h b/drivers/net/nfp/flower/nfp_flower.h
index b7ea830209..7d442e3cb2 100644
--- a/drivers/net/nfp/flower/nfp_flower.h
+++ b/drivers/net/nfp/flower/nfp_flower.h
@@ -6,7 +6,7 @@
 #ifndef __NFP_FLOWER_H__
 #define __NFP_FLOWER_H__
 
-#include "../nfp_common.h"
+#include "../nfp_net_common.h"
 
 /* Extra features bitmap. */
 #define NFP_FL_FEATS_GENEVE             RTE_BIT64(0)
diff --git a/drivers/net/nfp/meson.build b/drivers/net/nfp/meson.build
index 4702f1cdf4..4b4c587d5d 100644
--- a/drivers/net/nfp/meson.build
+++ b/drivers/net/nfp/meson.build
@@ -28,7 +28,6 @@ sources = files(
         'nfpcore/nfp_rtsym.c',
         'nfpcore/nfp_target.c',
         'nfpcore/nfp6000_pcie.c',
-        'nfp_common.c',
         'nfp_cpp_bridge.c',
         'nfp_ctrl.c',
         'nfp_ethdev.c',
@@ -37,6 +36,7 @@ sources = files(
         'nfp_ipsec.c',
         'nfp_logs.c',
         'nfp_mtr.c',
+        'nfp_net_common.c',
         'nfp_rxtx.c',
 )
 
diff --git a/drivers/net/nfp/nfp_cpp_bridge.h b/drivers/net/nfp/nfp_cpp_bridge.h
index a1103e85e4..bf975ce7ba 100644
--- a/drivers/net/nfp/nfp_cpp_bridge.h
+++ b/drivers/net/nfp/nfp_cpp_bridge.h
@@ -6,7 +6,7 @@
 #ifndef __NFP_CPP_BRIDGE_H__
 #define __NFP_CPP_BRIDGE_H__
 
-#include "nfp_common.h"
+#include "nfp_net_common.h"
 
 int nfp_enable_cpp_service(struct nfp_pf_dev *pf_dev);
 int nfp_map_service(uint32_t service_id);
diff --git a/drivers/net/nfp/nfp_ctrl.c b/drivers/net/nfp/nfp_ctrl.c
index 6fc8cffd2e..a95e35c9a5 100644
--- a/drivers/net/nfp/nfp_ctrl.c
+++ b/drivers/net/nfp/nfp_ctrl.c
@@ -9,8 +9,8 @@
 
 #include "nfpcore/nfp_platform.h"
 
-#include "nfp_common.h"
 #include "nfp_logs.h"
+#include "nfp_net_common.h"
 
 static void
 nfp_net_tlv_caps_reset(struct nfp_net_tlv_caps *caps)
diff --git a/drivers/net/nfp/nfp_ethdev_vf.c b/drivers/net/nfp/nfp_ethdev_vf.c
index b9d7a7c5c0..51c474275e 100644
--- a/drivers/net/nfp/nfp_ethdev_vf.c
+++ b/drivers/net/nfp/nfp_ethdev_vf.c
@@ -12,8 +12,8 @@
 #include "nfdk/nfp_nfdk.h"
 #include "nfpcore/nfp_cpp.h"
 
-#include "nfp_common.h"
 #include "nfp_logs.h"
+#include "nfp_net_common.h"
 
 static void
 nfp_netvf_read_mac(struct nfp_net_hw *hw)
diff --git a/drivers/net/nfp/nfp_flow.h b/drivers/net/nfp/nfp_flow.h
index aeb24458f3..09e5b30dd8 100644
--- a/drivers/net/nfp/nfp_flow.h
+++ b/drivers/net/nfp/nfp_flow.h
@@ -6,7 +6,7 @@
 #ifndef __NFP_FLOW_H__
 #define __NFP_FLOW_H__
 
-#include "nfp_common.h"
+#include "nfp_net_common.h"
 
 /* The firmware expects lengths in units of long words */
 #define NFP_FL_LW_SIZ                   2
diff --git a/drivers/net/nfp/nfp_ipsec.c b/drivers/net/nfp/nfp_ipsec.c
index a76ba2a91d..f137e4b50c 100644
--- a/drivers/net/nfp/nfp_ipsec.c
+++ b/drivers/net/nfp/nfp_ipsec.c
@@ -12,9 +12,9 @@
 #include <ethdev_driver.h>
 #include <ethdev_pci.h>
 
-#include "nfp_common.h"
 #include "nfp_ctrl.h"
 #include "nfp_logs.h"
+#include "nfp_net_common.h"
 #include "nfp_rxtx.h"
 
 #define NFP_UDP_ESP_PORT            4500
diff --git a/drivers/net/nfp/nfp_common.c b/drivers/net/nfp/nfp_net_common.c
similarity index 99%
rename from drivers/net/nfp/nfp_common.c
rename to drivers/net/nfp/nfp_net_common.c
index 2d4a7635ab..189f81bbb6 100644
--- a/drivers/net/nfp/nfp_common.c
+++ b/drivers/net/nfp/nfp_net_common.c
@@ -5,7 +5,7 @@
  * Small portions derived from code Copyright(c) 2010-2015 Intel Corporation.
  */
 
-#include "nfp_common.h"
+#include "nfp_net_common.h"
 
 #include <rte_alarm.h>
 
diff --git a/drivers/net/nfp/nfp_common.h b/drivers/net/nfp/nfp_net_common.h
similarity index 99%
rename from drivers/net/nfp/nfp_common.h
rename to drivers/net/nfp/nfp_net_common.h
index c7f467e33c..cf08df4618 100644
--- a/drivers/net/nfp/nfp_common.h
+++ b/drivers/net/nfp/nfp_net_common.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef __NFP_COMMON_H__
-#define __NFP_COMMON_H__
+#ifndef __NFP_NET_COMMON_H__
+#define __NFP_NET_COMMON_H__
 
 #include <bus_pci_driver.h>
 #include <ethdev_driver.h>
@@ -451,4 +451,4 @@ bool nfp_net_is_valid_nfd_version(struct nfp_net_fw_ver version);
 #define NFP_PRIV_TO_APP_FW_FLOWER(app_fw_priv)\
 	((struct nfp_app_fw_flower *)app_fw_priv)
 
-#endif /* __NFP_COMMON_H__ */
+#endif /* __NFP_NET_COMMON_H__ */